/*==========================================================================*/
/*Project Name:RUPUTER                                                 		*/
/* Copyright (c) Seiko Instruments Inc. 1998-1999. All rights reserved. 	*/
/*                                                           	        	*/
/* Function Outline : GNU -> Panax Converter								*/
/*                                                                      	*/
/*==========================================================================*/

int convGnuToPanaxPIL(void *p0,int i,long l,int *func)
{
	/* 1st arg register	GNU=D0,Panax=A0		*/
	/* 2nd arg register	GNU=D1,Panax=D0		*/
	/* long low-order	A2+0(+4),Panax=A3+A	*/
	/* long high-order	A2+2(+4),Panax=A3+C	*/
	/* Call function	A2+4(+4) -> A1		*/
	asm("
		add -8,A3
		mov	A0,(0,A3)
		mov	A1,(4,A3)

		add		-0x0E,A3		#Virtual Panax stack push 4+1*4byte+3*2byte
			movx	D0,(0x04,A3)	#arg1
			mov		D0,A0

			mov		(0x04,A2),D0	#A2 +4(Include ret)
			mov		D0,(0x0A,A3)	#long low-order

			mov		(0x06,A2),D0
			mov		D0,(0x0C,A3)	#long high-order

			mov		D1,(0x08,A3)	#arg2
			mov		D1,D0

			mov		(0x08,A2),A1	#Call function
			jsr		(A1)
		add		0x0E,A3			#Virtual Panax stack pop

		mov	(0,A3),A0
		mov	(4,A3),A1
		add	8,A3
	");
}

