/*==========================================================================*/
/*Project Name:RUPUTER                                                      */
/* Copyright (c) Seiko Instruments Inc. 1998-1999. All rights reserved.     */
/*																			*/
/*  Function outline: Call upload process									*/
/*																			*/
/*==========================================================================*/

#define RSHELL_PROC		0x24d800
#define UPLOAD_PROC		(RSHELL_PROC + 0x05)


int uplcall(char *filename, long filesize, int date, int time, int attribute)
{
	/* 1st register		GNU=D0,Panax=A0			*/
	/* long(low-orde)	GNU=A2+0(+4),Panax=A3+8	*/
	/* long(high-order)	GNU=A2+2(+4),Panax=A3+A	*/
	/* 3rd register		GNU=A2+4(+4),Panax=D0	*/
	/* 4th register		GNU=A2+6(+4),Panax=D1	*/
	/* 5th register		GNU=A2+8(+4),Panax=A3+10*/
	/* Call func		A1						*/

	asm("
		add		-8,A3							#
		mov		A0,(0,A3)						#
		mov		A1,(4,A3)						#

		add		-0x12,A3		#Virtual Panax stack push 4+3*4byte+1*2byte
			movx	D0,(0x04,A3)	#arg1
			mov		D0,A0

			mov		(0x04,A2),D0	#A2 +4(Involve ret)
			mov		D0,(0x08,A3)	#long low-order

			mov		(0x06,A2),D0
			mov		D0,(0x0A,A3)	#long high-order

			mov		(0x08,A2),D0	#arg3
			movx	D0,(0x0C,A3)	

			mov		(0x0A,A2),D1
			movx	D1,(0x0E,A3)	#arg4

			mov		(0x0C,A2),A1
			mov		A1,(0x10,A3)	#arg5

			mov		0x24d805,A1
			jsr		(A1)
		add		0x12,A3			#Virtual Panax stack pop

		mov		(0,A3),A0						#
		mov		(4,A3),A1						#
		add		8,A3							#
	");

/*******************************************************************
	int		(*func)(char *, long, int, int, int) = 
				(int (*)(char *, long, int, int, int))UPLOAD_PROC;
	return(func(filename, filesize, date, time, attribute));
********************************************************************/
}
